<?php

include('listtable.php');

if (isset($_REQUEST['action']) && current_user_can('manage_options')) {
    
    switch ($_REQUEST['action']) {
        case $this->slug.'_del_map':
            $map_id = intval($_REQUEST['map_id']);
            
            $this->Subject('delete_by_map',array($map_id));
            $this->Point('delete_by_map',array($map_id));
            $this->Map('delete',array($map_id));
            
            break;
        case $this->slug.'_import_map':
            
            $this->Import('maps');
            
            break;
    }
    
}

$maps = $this->Map('get');

echo "<h2>" . __( 'Maps', $this->slug ) . "</h2>";

?>

<div class="zoomable-map maps">
    
    <div id="tabs" style="display: none;">
        
        <ul>
            <li><a href="#tabs-1"><?php _e('Maps',$this->slug); ?></a></li>
        </ul>
        
        <div id="tabs-1">
        
            <?php
                
                $args = array(
                              'singular'            => 'map',
                              'plural'              => 'maps',
                              'ajax'                => false,
                              'per_page'            => -1,
                              'columns'             => array(
                                                             'cb'           => '<input type="checkbox" />',
                                                             'name'         => 'Name',
                                                             'shortcode'    => 'ShortCode',
                                                             'width'        => 'Width',
                                                             'height'       => 'Height',
                                                             'colors'       => 'Colors',
                                                             'isResponsive' => 'Is responsive',
                                                             'iOSbehavior'  => 'iOS behavior mode',
                                                             ),
                              'sortable_columns'    => array('name' => array('name',false)),
                              'actions'             => array(),
                              'column_name'         => function($value,$item) {
                                global $Zoomable_Map_World;
                                return '<span data-id="'.$item['id'].'">'.$value.'</span>
                                        <div class="row-actions">
                                            <span class="edit">
                                                <a href="#" class="editinplace">Edit</a> | 
                                            </span>
                                            <span class="settings">
                                                <a href="admin.php?page='.$Zoomable_Map_World->slug.'-settings&map_id='.$item['id'].'">Settings</a> | 
                                            </span>
                                            <span class="view">
                                                <a href="'.$Zoomable_Map_World->ajax_url.'?ajax=1&action=zoomable_map_action&subaction=map_preview&map_id='.$item['id'].'" target="_blank">Preview</a> | 
                                            </span>
                                            <span class="trash">
                                                <a href="#">Delete</a>
                                            </span>
                                        </div>';
                                
                              },
                              'column_shortcode'    => function($value,$item) {
                                    global $Zoomable_Map_World;
                                    return '['.$Zoomable_Map_World->slug.' id="'.$item['id'].'"]';
                              },
                              'column_colors'       => function($value,$item) {
                                global $Zoomable_Map_World;
                                
                                $_this = $Zoomable_Map_World;
                                
                                return '<span style="background:'.$item['borderColor'].'; color: '.$_this->invert_color($item['borderColor']).'" title="Borders color">'.strtoupper($item['borderColor']).'</span>
                                        <span style="background:'.$item['borderColorOver'].'; color: '.$_this->invert_color($item['borderColorOver']).'" title="Borders color hover">'.strtoupper($item['borderColorOver']).'</span>
                                        <span style="background:'.$item['backgroundColor'].'; color: '.$_this->invert_color($item['backgroundColor']).'" title="Background color" >'.strtoupper($item['backgroundColor']).'</span>';
                                
                              },
                              'column_isResponsive' => function($value,$item) {
                                   return $value ? 'Yes' : 'No';
                              },
                              'column_iOSbehavior' => function($value,$item) {
                                   return $value ? 'Yes' : 'No';
                              },
                              'data'                => function() {
                                    global $Zoomable_Map_World;
                                    
                                    $results = $Zoomable_Map_World->Map('get');
                                    $data    = array();
                                    foreach($results as $result) {
                                        $result = (array)$result;
                                        
                                        foreach($result as $key => $value) {
        
                                            $result[$key] = htmlspecialchars_decode($value,ENT_QUOTES);
                                            $result[$key] = htmlspecialchars_decode($result[$key],ENT_QUOTES);
                                        }
                                        
                                        $data[] = $result;
                                    }
        
                                    return $data;
                              },
                              'actions' => function () {
                                    $actions = array(
                                        'export'    => 'Export',
                                        'delete'    => 'Delete',
                                    );
                                    return $actions;
                              },
                              'process_bulk_action' => function($action) {
                                    global $Zoomable_Map_World;
                                    
                                    switch($action) {
                                        case 'export':
                                            break;
                                        case 'delete':
                                            $Zoomable_Map_World->Subject('delete_by_map',array($_REQUEST['map']));
                                            $Zoomable_Map_World->Point('delete_by_map',array($_REQUEST['map']));
                                            $Zoomable_Map_World->Map('delete',array($_REQUEST['map']));
                                            break;
                                    } 
                              },
                              );
            
                $ListTable = new List_Table($args);
                $ListTable->prepare_items();
                
            ?>
        
            <form id="maps-form" method="get">
           
                <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
        
                <div class="filter-keyup">
                    Filter: <input type="text" name="filter" value="" autocomplete="off" /><div class="filter-clear dashicons-before dashicons-dismiss"></div>
                </div>
        
                <input type="submit" class="button button-primary add-new" value="<?php echo __( 'Add new map', $this->slug ); ?>" />
                <input type="submit" class="button button-secondary import" value="<?php echo __( 'Import maps', $this->slug ); ?>" />
        
                <?php $ListTable->display() ?>
                
            </form>
            
            <div style="clear: both; height: 10px; "></div>
            
            <form name="action_form" method="POST" enctype="multipart/form-data">
                <input type="hidden" name="action" value="" />
                <input type="hidden" name="map_id" value="<?php echo $map_id; ?>" />
                
                <div style="visibility: hidden; height: 0;">
                    <input type="file" name="<?php echo $this->slug.'_import_file'; ?>" />
                </div>
                
                <input type="submit" class="button button-primary add-new" value="<?php echo __( 'Add new map', $this->slug ); ?>" />
                <input type="submit" class="button button-secondary import" value="<?php echo __( 'Import maps', $this->slug ); ?>" />
            </form>
            
            <div style="clear: both; height: 10px; "></div>
            
            <div class="place_editor map" style="display: none">
                        
                <input type="hidden" name="id" value="" />
                <input type="hidden" name="type" value="map" />
                
                <span class="title">Name: </span>
                <input type="text" name="name" value="" class="long" autocomplete="off" />
                <span class="tooltip dashicons-before dashicons-editor-help" title="Name of the map"></span>
                
                <div style="clear: both; height: 10px;"></div>
                
                <span class="title">Borders Color: </span>
                <input type="text" name="borderColor" value="" class="short" autocomplete="off" />
                <span class="tooltip dashicons-before dashicons-editor-help" title="The color of borders on the map"></span>
                <div class="colorpicker"></div>
                <br />
                
                <span class="title">Borders hover color: </span>
                <input type="text" name="borderColorOver" value="" class="short" autocomplete="off" />
                <span class="tooltip dashicons-before dashicons-editor-help" title="The color of hovered borders on the map"></span>
                <div class="colorpicker"></div>
                <br />
                
                <span class="title">Background color: </span>
                <input type="text" name="backgroundColor" value="" class="short" autocomplete="off" />
                <span class="tooltip dashicons-before dashicons-editor-help" title="The color of background on the map"></span>
                <div class="colorpicker"></div>
                <br />
                
                <div style="clear: both; height: 10px;"></div>
                
                <span class="title">Layout type: </span>
                <label class="radio">Not Responsive: <input type="radio" name="isResponsive" value=0 /></label>&nbsp;&nbsp;&nbsp;&nbsp;
                <label class="radio">Responsive: <input type="radio" name="isResponsive" value=1 /></label>
                <span class="tooltip dashicons-before dashicons-editor-help" title="Type of the layout"></span><br />
                
                <span class="title">iOS behavior mode: </span>
                <label class="radio">No: <input type="radio" name="iOSbehavior" value=0 /></label>&nbsp;&nbsp;&nbsp;&nbsp;
                <label class="radio">Yes: <input type="radio" name="iOSbehavior" value=1 /></label>
                <span class="tooltip dashicons-before dashicons-editor-help" title="iOS behavior mode"></span><br />
                
                <div style="clear: both; height: 10px;"></div>
            
                <span class="title">Map width: </span><input class="span2" type="text" name="width" value="" />
                <span class="tooltip dashicons-before dashicons-editor-help" title="The width of the map"></span><br />
            
                <span class="title">Map height: </span><input class="span2" type="text" name="height" value="" />
                <span class="tooltip dashicons-before dashicons-editor-help" title="The height of the map"></span><br />
                
                <div style="clear: both; height: 20px;"></div>
                
                <input type="button" class="button button-primary" value="Save Changes" />
                <input type="button" class="button button-secondary cancel" value="Cancel" />
                
            </div>
    
        </div>

    </div>
    
</div>


<script type="text/javascript">
    
    Zmap.options.slug     = '<?php echo $this->slug; ?>';
    Zmap.options.path     = '<?php echo plugins_url('/../', __FILE__); ?>';
    Zmap.options.ajax_url = '<?php echo $this->ajax_url; ?>';
    
</script>

<script type="text/javascript" src="<?php echo plugins_url('/../js/admin-maps.js',__FILE__); ?>"></script>
