<?php

global $map_id;

if (isset($_REQUEST['action']) && current_user_can('manage_options')) {
    
    switch ($_REQUEST['action']) {
        case $this->slug.'_del_point':
            $point_id = intval($_REQUEST['point_id']);
            
            $this->Point('delete',array($point_id));
            
            break;
        case $this->slug.'_import_point':
            
            $this->Import('points',$map_id);
            
            break;
    }
    
}   
            
$args = array(
              'singular'            => 'point',
              'plural'              => 'points',
              'ajax'                => false,
              'per_page'            => -1,
              'columns'             => array(
                                             'cb'       => '<input type="checkbox" />',
                                             'name'     => 'Name',
                                             'marker'   => 'Marker',
                                             'comment'  => 'Comment',
                                             'image'    => 'Image',
                                             'link'     => 'Link',
                                             'lat-lon'  => 'Latitude/Longitude',
                                             ),
              'sortable_columns'    => array('name' => array('name',false)),
              'actions'             => array(),
              'column_name'         => function($value,$item) {
                
                return '<span data-id="'.$item['id'].'" data-active="'.$item['active'].'">'.$value.'</span>
                        <div class="row-actions">
                            <span class="edit">
                                <a href="#" class="editinplace point">Edit</a> |
                            </span>
                            <span class="trash">
                                <a href="#">Delete</a>
                            </span>
                        </div>';
                
              },
              'column_marker'       => function($value,$item) {
                    global $Zoomable_Map_World;
                    
                    $_this = $Zoomable_Map_World;
            
                    return '<div data-color="'.$item['color'].'" data-color2="'.$item['color2'].'" data-icon="'.$item['iconType'].'" class="awesome-marker preview awesome-marker-icon-'.$item['color'].'" style="position: relative; float: left"><i class=" fa fa-'.$item['iconType'].' icon-white"></i></div>';
              },
              'column_comment'      => function($value,$item) {
                    return  '<div>'.$value.'</div>';
              },
              'column_image'        => function($value,$item) {
                    return (!empty($value)) ? '<img src="'.$value.'" />' : '<img src="" style="display:none;" />';
              },
              'column_link'         => function($value,$item) {
                    return (!empty($value)) ? '<a href="'.$value.'" target="'.$item['target'].'">'.$value.'</a>' : '<a href="#" target="'.$item['target'].'"></a>';
              },
              'column_lat-lon'      => function($value,$item) {
                    return '<span>'.$item['latitude'].'</span><br />
                            <span>'.$item['longitude'].'</span>';
              },
              'data'                => function() {
                    global $Zoomable_Map_World, $map_id;
                    
                    $results = $Zoomable_Map_World->Point('get_by_map',array($map_id,'*'));
                    $data    = array();
                    foreach((array)$results as $result) {
                        $result = (array)$result;
                        
                        foreach($result as $key => $value) {

                            $result[$key] = htmlspecialchars_decode($value,ENT_QUOTES);
                            $result[$key] = htmlspecialchars_decode($result[$key],ENT_QUOTES);
                        }
                        
                        $data[] = $result;
                    }

                    return $data;
              },
              'actions' => function () {
                            $actions = array(
                                'delete'    => 'Delete',
                                'export'    => 'Export'
                            );
                            return $actions;
              },
              'process_bulk_action' => function($action) {
                    global $Zoomable_Map_World;
                    
                    switch($action) {
                        case 'export':
                            break;
                        case 'delete':
                            $Zoomable_Map_World->Point('delete',array($_REQUEST['point']));
                            break;
                    } 
              },
              );

$ListTable = new List_Table($args);
$ListTable->prepare_items();

$colors = array('red','darkred','lightred','orange','beige','green','darkgreen','lightgreen','blue','darkblue','lightblue','purple','darkpurple','pink','cadetblue','white','gray','lightgray','black');
 
?>

<form id="points-form" method="get">

    <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />

    <div class="filter-keyup">
        Filter: <input type="text" name="filter" value="" autocomplete="off" /><div class="filter-clear dashicons-before dashicons-dismiss"></div>
    </div>

    <input type="submit" class="button button-primary add-new" value="<?php echo __( 'Add new point', $this->slug ); ?>" />
    <input type="submit" class="button button-secondary import" value="<?php echo __( 'Import points', $this->slug ); ?>" />
    
    <?php $ListTable->display() ?>
    
</form>

<div style="clear: both; height: 10px; "></div>

<form name="action_form" method="POST" enctype="multipart/form-data">
    <input type="hidden" name="action" value="" />
    <input type="hidden" name="point_id" value="" />
    
    <div style="visibility: hidden; height: 0;">
        <input type="file" name="<?php echo $this->slug.'_import_file'; ?>" />
    </div>
    
    <input type="submit" class="button button-primary add-new" value="<?php echo __( 'Add new point', $this->slug ); ?>" />
    <input type="submit" class="button button-secondary import" value="<?php echo __( 'Import points', $this->slug ); ?>" />
</form>


<div class="place_editor point" style="display: none">
    
    <input type="hidden" name="id" value="" />
    <input type="hidden" name="map_id" value="<?php echo $map_id; ?>" />
    <input type="hidden" name="type" value="point" />
    
    <span class="title">Name: </span>
    <input type="text" name="name" value="" class="long" autocomplete="off" />
    <span class="tooltip dashicons-before dashicons-editor-help" title="Name of the point"></span>
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Color: </span>
    
    <div class="ui-widget" style="float: left">
        <select id="marker-colors" name="color" autocomplete="off">
            <option value="">Select one...</option>
            <?php foreach($colors as $color) { ?>
                <option value="<?php echo $color; ?>"><?php echo $color; ?></option>
            <?php } ?>
        </select>
    </div>&nbsp;
    <input type="checkbox" name="color_all" value="1" autocomplete="off" />&nbsp;Apply for all points 
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Color hover: </span>
    <div class="ui-widget" style="float: left">
        <select id="marker-colors2" name="color2" autocomplete="off">
            <option value="">Select one...</option>
            <?php foreach($colors as $color) { ?>
                <option value="<?php echo $color; ?>"><?php echo $color; ?></option>
            <?php } ?>
        </select>
    </div>&nbsp;
    <input type="checkbox" name="color2_all" value="1" autocomplete="off" />&nbsp;Apply for all points 
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Comment: </span>
    
    <a href="#" class="editor_toggle" data-toggle="Hide comment">Change comment</a>
    <div style="display: none">
        <?php
                                   
                                   
            $settings = array(
                               'media_buttons' => false,
                               'wpautop'       => false,
                               'teeny'         => true,
                               'textarea_rows' => 5,
                               'textarea_name' => 'comment'
                               );
                 
            wp_editor('', 'editorcomment_point', $settings);
         
    
        ?>
        <span class="tooltip dashicons-before dashicons-editor-help" title="Popup comment"></span>
    </div>
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Image: </span>
    <input type="text" name="image" value="" class="long" />
    <input type="button" class="button button-secondary image" value="Choose" autocomplete="off" />
    <span class="tooltip dashicons-before dashicons-editor-help" title="Popup image"></span>
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Link: </span>
    <input type="text" name="link" value="" class="long" autocomplete="off" />
    <select name="target" class="short" autocomplete="off">
        <option value=""></option>
        <option value="_self">_self</option>
        <option value="_blank">_blank</option>
    </select>
    <span class="tooltip dashicons-before dashicons-editor-help" title="Link of the point and target"></span>
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Icon: </span>
    <input type="text" name="iconType" value="" class="long" autocomplete="off" />
    <select name="iconSize" class="short" autocomplete="off" style="display: none;">
        <option value="s">small</option>
        <option value="m">medium</option>
        <option value="l">large</option>
    </select>
    <span class="tooltip dashicons-before dashicons-editor-help" title="Icon of the point"></span>
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Latitude: </span>
    <input type="text" name="latitude" value="" class="short" autocomplete="off" />
    <span class="tooltip dashicons-before dashicons-editor-help" title="Latitude of the point"></span>
    <br />
    
    <span class="title">Longitude: </span>
    <input type="text" name="longitude" value="" class="short" autocomplete="off" />
    <span class="tooltip dashicons-before dashicons-editor-help" title="Longitude of the point"></span>
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Active: </span>
    <select name="active" class="short" autocomplete="off">
        <option value="1">Active</option>
        <option value="0">Not active</option>
    </select>
    <span class="tooltip dashicons-before dashicons-editor-help" title="Point is active or not"></span>
    
    <div style="clear: both; height: 20px;"></div>
    
    <input type="button" class="button button-primary" value="Save Changes" />
    <input type="button" class="button button-secondary cancel" value="Cancel" />
    
</div>


<script type="text/javascript" src="<?php echo plugins_url('/../js/admin-points.js',__FILE__); ?>"></script>