<?php
            
    $args = array(
                  'singular'            => 'subject',
                  'plural'              => 'subjects',
                  'ajax'                => false,
                  'per_page'            => -1,
                  'columns'             => array(
                                                 'cb'      => '<input type="checkbox" />',
                                                 'name'    => 'Name',
                                                 'colors'  => 'Colors',
                                                 'comment' => 'Comment',
                                                 'image'   => 'Image',
                                                 'link'    => 'On click',
                                                 ),
                  'sortable_columns'    => array('name' => array('name',false)),
                  'actions'             => array(),
                  'column_name'         => function($value,$item) {
                    
                    return '<span data-id="'.$item['id'].'">'.$value.'</span>
                            <div class="row-actions">
                                <span class="edit">
                                    <a href="#" class="editinplace subject">Edit</a>
                                </span>
                            </div>';
                    
                  },
                  'column_colors'       => function($value,$item) {
                        global $Zoomable_Map_World;
                        
                        $_this = $Zoomable_Map_World;
                
                        return '<span style="background:'.$item['color'].'; color: '.$_this->invert_color($item['color']).'" title="Background color">'.strtoupper($item['color']).'</span>
                                <span style="background:'.$item['color2'].'; color: '.$_this->invert_color($item['color2']).'" title="Background color hover">'.strtoupper($item['color2']).'</span>';
                  },
                  'column_comment'      => function($value,$item) {
                        return  '<div>'.$value.'</div>';
                  },
                  'column_image'        => function($value,$item) {
                        return (!empty($value)) ? '<img src="'.$value.'" />' : '<img src="" style="display:none;" />';
                  },
                  'column_link'         => function($value,$item) {
                    
                        if (substr($value,0,25)=='javascript:Zmap.show_more') {
                            return '<a href="'.$value.'" target="'.$item['target'].'" style="display:none">'.$value.'</a><div>'.$item['comment2'].'</div>';
                        } else {
                            return (!empty($value)) ? '<a href="'.$value.'" target="'.$item['target'].'">'.$value.'</a><div></div>' : '<a href="#" target="'.$item['target'].'"></a><div></div>';
                        }
                    
                  },
                  'data'                => function() {
                        global $Zoomable_Map_World, $map_id;
                        
                        $results = $Zoomable_Map_World->Subject('get_by_map',array($map_id,'*'));
                        $data    = array();
                        foreach($results as $result) {
                            $result = (array)$result;
                            
                            foreach($result as $key => $value) {

                                $result[$key] = htmlspecialchars_decode($value,ENT_QUOTES);
                                $result[$key] = htmlspecialchars_decode($result[$key],ENT_QUOTES);
                            }
                            
                            $data[] = $result;
                        }

                        return $data;
                  },
                  );

    $ListTable = new List_Table($args);
    $ListTable->prepare_items();
    
?>

<form id="subjects-form" method="get">

    <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />

    <div class="filter-keyup">
        Filter: <input type="text" name="filter" value="" autocomplete="off" /><div class="filter-clear dashicons-before dashicons-dismiss"></div>
    </div>

    <?php $ListTable->display() ?>
    
</form>

<div style="clear: both; height: 10px; "></div>

<div class="place_editor subject" style="display: none">
    
    <input type="hidden" name="id" value="" />
    <input type="hidden" name="map_id" value="<?php echo $map_id; ?>" />
    <input type="hidden" name="type" value="subject" />
    
    <span class="title">Name: </span>
    <input type="text" name="name" value="" class="long" autocomplete="off" />
    <span class="tooltip dashicons-before dashicons-editor-help" title="Name of the country"></span>
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Color: </span>
    <input type="text" name="color" value="" class="short" autocomplete="off" />
    <span class="tooltip dashicons-before dashicons-editor-help" title="Color of the country"></span>
    <div class="colorpicker"></div>
    <input type="checkbox" name="color_all" value="1" autocomplete="off" />&nbsp;Apply for all countries 
    <br />
    
    <span class="title">Color hover: </span>
    <input type="text" name="color2" value="" class="short" autocomplete="off" />
    <span class="tooltip dashicons-before dashicons-editor-help" title="Color of the hovered country"></span>
    <div class="colorpicker"></div>
    <input type="checkbox" name="color2_all" value="1" autocomplete="off" />&nbsp;Apply for all countries 
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Comment: </span>
    <a href="#" class="editor_toggle" data-toggle="Hide comment">Change comment</a>
    
    <div style="display: none">
        <?php
                                   
                                   
            $settings = array(
                               'media_buttons' => false,
                               'wpautop'       => false,
                               'teeny'         => true,
                               'textarea_rows' => 5,
                               'textarea_name' => 'comment'
                               );
                 
            wp_editor('', 'editorcomment_subject', $settings);
         
    
        ?>
        <span class="tooltip dashicons-before dashicons-editor-help" title="Popup comment"></span>
    </div>
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">Image: </span>
    <input type="text" name="image" value="" class="long" />
    <input type="button" class="button button-secondary image" value="Choose" autocomplete="off" />
    <span class="tooltip dashicons-before dashicons-editor-help" title="Popup image"></span>
    
    <div style="clear: both; height: 10px;"></div>
    
    <span class="title">What to do when the country is clicked: </span>
    <input type="radio" name="click_type" value="0" autocomplete="off" />&nbsp;Nothing
    <span class="tooltip dashicons-before dashicons-editor-help" title="Do not react on mouse clicks"></span>
    <input type="radio" name="click_type" value="1" autocomplete="off" />&nbsp;Open a URL
    <span class="tooltip dashicons-before dashicons-editor-help" title="A click on this subject opens a specified URL"></span>
    <input type="radio" name="click_type" value="2" autocomplete="off" />&nbsp;Show more info
    <span class="tooltip dashicons-before dashicons-editor-help" title="Displays a side-panel with additional information (contacts, addresses etc.)"></span>
    
    <div style="clear: both; height: 10px;"></div>
    
    <div class="click_type1">
        <span class="title">Link: </span>
        <input type="text" name="link" value="" class="long" autocomplete="off" />
        <select name="target" autocomplete="off">
            <option value=""></option>
            <option value="_self">_self</option>
            <option value="_blank">_blank</option>
        </select>
        <span class="tooltip dashicons-before dashicons-editor-help" title="Link and target"></span>
        
        <div style="clear: both; height: 10px;"></div>
    </div>
    
    <div class="click_type2">
        <span class="title">More info: </span>
        <a href="#" class="editor_toggle" data-toggle="Hide info">Change info</a>
        
        <div style="display: none">
            <?php
                                       
                                       
                $settings = array(
                                   'media_buttons' => false,
                                   'wpautop'       => false,
                                   'teeny'         => true,
                                   'textarea_rows' => 5,
                                   'textarea_name' => 'comment2'
                                   );
                     
                wp_editor('', 'editorcomment2_subject', $settings);
             
        
            ?>
            <span class="tooltip dashicons-before dashicons-editor-help" title="More info"></span>
        </div>
    </div>
    
    <div style="clear: both; height: 20px;"></div>
    
    <input type="button" class="button button-primary" value="Save Changes" />
    <input type="button" class="button button-secondary cancel" value="Cancel" />
    
</div>

<script type="text/javascript" src="<?php echo plugins_url('/../js/admin-subjects.js',__FILE__); ?>"></script>