<?php

global $map_id;

include('listtable.php');

add_filter( 'wp_default_editor',function () { return "tinymce"; } );

$maps       = $this->Map('get');
$map_ids    = array_keys($maps);
$map_id     = (isset($_REQUEST['map_id'])) ? intval($_REQUEST['map_id']) : array_shift($map_ids) ;

echo "<h2>" . __( 'Map detailed settings', $this->slug ) . "</h2>";

?>

<div class="zoomable-map subjects">

    <select name="map_id">
        <?php foreach($maps as $id => $map_data) { ?>
            <option value="<?php echo $id; ?>" <?php echo ($id==$map_id)?'selected':'';?>><?php echo $map_data->name; ?></option>
        <?php } ?>
    </select>
    
    <div id="tabs" style="display: none;">
        
        <ul>
            <li data-n="0"><a href="#tabs-1"><?php _e('Countries',$this->slug); ?></a></li>
            <li data-n="1"><a href="#tabs-2"><?php _e('Points',$this->slug); ?></a></li>
            <li data-n="2"><a href="#tabs-3"><?php _e('Preview',$this->slug); ?></a></li>
        </ul>
        
        <div id="tabs-1">
        
            <?php include('page-settings-subjects.php'); ?>
        
        </div>
        
        <div id="tabs-2">
            
            <?php include('page-settings-points.php'); ?>
            
        </div>
        
        <div id="tabs-3">
            
            <iframe src="" style="width: 100%; min-height:1000px" id="map-preview"></iframe>
            
        </div>

    </div>
    

</div>


<script type="text/javascript">
    
    Zmap.options.slug     = '<?php echo $this->slug; ?>';
    Zmap.options.path     = '<?php echo plugins_url('/../', __FILE__); ?>';
    Zmap.options.ajax_url = '<?php echo $this->ajax_url; ?>';
    
    jQuery(document).ready(function() {
        
        jQuery('select[name=map_id]').change(function() {
            location.href = 'admin.php?page=<?php echo $this->slug; ?>-settings&map_id='+jQuery(this).val();
        });
        
    });
    
</script>
