(function($) {

$(document).ready(function() {

    $('.editinplace').click(function() {
    
        Zmap.admin.placeeditor.show('.place_editor.map',$(this),function() {
            
            var dom  = Zmap.admin.placeeditor.dom, tr = Zmap.admin.placeeditor.tr;
            
            var id   = $(tr).find('td.name span:eq(0)').attr('data-id');
            $(dom).find('input[name=id]').val(id);
            
            var name = $(tr).find('td.name span:eq(0)').html();
            $(dom).find('input[name=name]').val(name);
            
            var borderColor  = $(tr).find('td.colors span:eq(0)').html();
            $(dom).find('input[name=borderColor]').val(borderColor).css({background: borderColor});
            
            var borderColorOver  = $(tr).find('td.colors span:eq(1)').html();
            $(dom).find('input[name=borderColorOver]').val(borderColorOver).css({background: borderColorOver});
            
            var backgroundColor  = $(tr).find('td.colors span:eq(2)').html();
            $(dom).find('input[name=backgroundColor]').val(backgroundColor).css({background: backgroundColor});

            
            var isResponsive = ($(tr).find('td.isResponsive').html()=='Yes') ? 1 : 0;
            $(dom).find('input[name=isResponsive]').filter('*[value='+isResponsive+']').attr('checked','checked');
            
            if (isResponsive==1) {
                $(dom).find('input[name=width],input[name=height]').attr('disabled','disabled');
            }
            
            var iOSbehavior = ($(tr).find('td.iOSbehavior').html()=='Yes') ? 1 : 0;
            $(dom).find('input[name=iOSbehavior]').filter('*[value='+iOSbehavior+']').attr('checked','checked');
            
            
            var width = $(tr).find('td.width').html();
            $(dom).find('input[name=width]').val(width);
            
            var height = $(tr).find('td.height').html();
            $(dom).find('input[name=height]').val(height);
            
            
        });
        
        return false;
    });
    
    $('.place_editor .button-primary').click(function() {
        
        Zmap.admin.placeeditor.save('.place_editor.map',function() {
            
            var tr = Zmap.admin.placeeditor.tr, values = Zmap.admin.placeeditor.values;
            
            if (values.id=='new') { location.reload(true); return false; }
            
            $(tr).find('td.name span:eq(0)').html(values.name);
            
            $(tr).find('td.colors span:eq(0)').html(values.borderColor.toUpperCase()).css({background: values.borderColor});
            $(tr).find('td.colors span:eq(1)').html(values.borderColorOver.toUpperCase()).css({background: values.borderColorOver});
            $(tr).find('td.colors span:eq(2)').html(values.backgroundColor.toUpperCase()).css({background: values.backgroundColor});
            
            $(tr).find('td.isResponsive').html( (values.isResponsive==1) ? 'Yes' : 'No' );
            $(tr).find('td.iOSbehavior').html( (values.iOSbehavior==1) ? 'Yes' : 'No' );
           
            $(tr).find('td.width').html(values.width);
            $(tr).find('td.height').html(values.height);
            
        });
        
        return false; 

    });
    
    $('.row-actions .trash a').click(function() {
        if (confirm('Remove the map?\nAttention! All settings for the map will be deleted permanently!')) {
            
            var map_id = $(this).parent().parent().prev('span').attr('data-id');
            var form   = $('form[name=action_form]');
            
            $(form).find('input[name=action]').val(Zmap.options.slug+'_del_map');
            $(form).find('input[name=map_id]').val(map_id);
            $(form).submit();
            
            
        } else {
            return false;
        }
    });
    
    $('.button.add-new').click(function() {
    
        Zmap.admin.placeeditor.show('.place_editor.map',$(this),function() {
            
            var dom = Zmap.admin.placeeditor.dom;
            $(dom).find('input[name=id]').val('new');
            $(dom).find('input[name=name]').val('New map');
            
            $(dom).find('input[name=isResponsive]').filter('*[value=0]').attr('checked','checked');
            $(dom).find('input[name=iOSbehavior]').filter('*[value=0]').attr('checked','checked');
            
            $(dom).find('input[name=width]').val(670).attr('disabled',false);
            $(dom).find('input[name=height]').val(350).attr('disabled',false);
            
            $(dom).find('input[name=borderColor]').val('#ffffff');
            $(dom).find('input[name=borderColorOver]').val('#003c77');
            $(dom).find('input[name=backgroundColor]').val('#ffffff');
            
        });
        
        return false;    
    });
    
    $('.button.import').click(function() {
    
        $('form[name=action_form]').find('input[type=file]').click();
        
        return false;    
    });
    
    $('form[name=action_form]').find('input[type=file]').change(function() {
        $('form[name=action_form]').find('input[name=action]').val(Zmap.options.slug+'_import_map');
        $('form[name=action_form]').submit();
    });
    
    $('input[name=isResponsive]').change(function() {
    
        if ($('input[name=isResponsive]:checked').val()==1) {
            $('input[name=width],input[name=height]').attr('disabled','disabled');
        } else {
            $('input[name=width],input[name=height]').attr('disabled',false);
        }
        
        return false;    
    });
    
    Zmap.admin.filter.bind('#maps-form');
    
});

})(jQuery);