(function($) {

$(document).ready(function() {
        
    $('.editinplace.point').click(function() {
    
        Zmap.admin.placeeditor.show('.place_editor.point',$(this),function() {
            
            var dom = Zmap.admin.placeeditor.dom, tr = Zmap.admin.placeeditor.tr;
            
            var id = $(tr).find('td.name span:eq(0)').attr('data-id');
            $(dom).find('input[name=id]').val(id);
            
            var name = $(tr).find('td.name span:eq(0)').html();
            $(dom).find('input[name=name]').val(name);
            
            var color   = $(tr).find('td.marker div:eq(0)').attr('data-color');
            $(dom).find('select[name=color]').val(color).next('.custom-combobox').find('input').val(color);

            var color2  = $(tr).find('td.marker div:eq(0)').attr('data-color2');
            $(dom).find('select[name=color2]').val(color2).next('.custom-combobox').find('input').val(color2);
            
            var comment = $(tr).find('td.comment div:eq(0)').html();
            tinyMCE.get('editorcomment_point').setContent(comment);
            
            var image = $(tr).find('td.image img').attr('src');
            $(dom).find('input[name=image]').val(image);
            
            var link = $(tr).find('td.link a').attr('href'); if (link=='#') { link=''; }
            
            $(dom).find('input[name=link]').val(link);
            
            var target = $(tr).find('td.link a').attr('target');
            $(dom).find('select[name=target]').val(target);
            
            var iconType = $(tr).find('td.marker div:eq(0)').attr('data-icon');
            $(dom).find('input[name=iconType]').val(iconType).next('.custom-combobox').find('input').val(iconType);
            
            var latitude = $(tr).find('td.lat-lon span:eq(0)').text();
            $(dom).find('input[name=latitude]').val(latitude);
            
            var longitude = $(tr).find('td.lat-lon span:eq(1)').text();
            $(dom).find('input[name=longitude]').val(longitude);
            
            var active = ($(tr).hasClass('not-active')) ? 0 : 1;
            $(dom).find('select[name=active]').val(active);
            
        });
        
        return false;
    });
     
    $('.place_editor.point .button-primary').click(function() {
        
        Zmap.admin.placeeditor.save('.place_editor.point',function() {
            
            var tr = Zmap.admin.placeeditor.tr, values = Zmap.admin.placeeditor.values;
            
            if (values.id=='new') { location.reload(true); return false; }
            
            $(tr).find('td.name span:eq(0)').html(values.name);
            
            
            if ($(Zmap.admin.placeeditor.dom).find('input[name=color_all]').attr('checked')=='checked') {
                
                $('td.marker:visible').each(function() {
                    $(this).find('.awesome-marker').attr('class','awesome-marker preview awesome-marker-icon-'+values.color).attr('data-color',values.color);
                });
                
            } else {
                $(tr).find('.awesome-marker').attr('class','awesome-marker preview awesome-marker-icon-'+values.color).attr('data-color',values.color);
            }
            
            
            if ($(Zmap.admin.placeeditor.dom).find('input[name=color2_all]').attr('checked')=='checked') {
                
                $('td.marker:visible').each(function() {
                    $(this).find('.awesome-marker').attr('data-color2',values.color2);
                });
                
            } else {
                $(tr).find('.awesome-marker').attr('data-color2',values.color2);
            }
            
            
            $(tr).find('td.comment div:eq(0)').html(values.comment);
            
            $(tr).find('td.image img').attr('src',values.image);
            if (values.image!='' && values.image!=null && values.image!=undefined) {
                $(tr).find('td.image img').show();
            } else {
                $(tr).find('td.image img').hide();
            }
            
            $(tr).find('td.link a').attr('href',values.link).attr('target',values.target).text(values.link);
            
            $(tr).find('td.marker i').attr('class','fa fa-'+values.iconType+' icon-white');
            
            $(tr).find('td.lat-lon span:eq(0)').html(values.latitude);
            $(tr).find('td.lat-lon span:eq(1)').html(values.longitude);
            
            if (values.active==0) {
                $(tr).addClass('not-active');
            } else {
                $(tr).removeClass('not-active');
            }
            
        });
        
        Zmap.admin.changes = true;
        
        return false; 

    });
    
    $('.row-actions .trash a').click(function() {
        if (confirm('Remove the point?\nAttention! All settings for the point will be deleted permanently!')) {
            
            var point_id = $(this).parent().parent().prev('span').attr('data-id');
            var form     = $('form[name=action_form]');
            
            $(form).find('input[name=action]').val(Zmap.options.slug+'_del_point');
            $(form).find('input[name=point_id]').val(point_id);
            $(form).submit();
            
            
        } else {
            return false;
        }
    });
    
    $('.button.add-new').click(function() {
    
        Zmap.admin.placeeditor.show('.place_editor.point',$(this),function() {
            
            var dom = Zmap.admin.placeeditor.dom;
            
            $(dom).find('input,select,textarea').not('*[type=hidden],*[type=button]').val('');
            tinyMCE.get('editorcomment_point').setContent('');
            
            $(dom).find('input[name=id]').val('new');
            $(dom).find('input[name=name]').val('New point');
            $(dom).find('select[name=active]').val(1);
            
        });
        
        return false;    
    });
    
    $('span[data-active=0]').parent().parent().each(function() {
        $(this).addClass('not-active');    
    });
 
    $('.button.import').click(function() {
    
        $('form[name=action_form]').find('input[type=file]').click();
        
        return false;    
    });
    
    $('form[name=action_form]').find('input[type=file]').change(function() {
        $('form[name=action_form]').find('input[name=action]').val(Zmap.options.slug+'_import_point');
        $('form[name=action_form]').submit();
    });
    
    $('.awesome-marker.preview').mouseover(function() {
        var color  = $(this).attr('data-color');
        var color2 = $(this).attr('data-color2');
        
        if (color!=color2)
        $(this).removeClass('awesome-marker-icon-'+color).addClass('awesome-marker-icon-'+color2);    
    });
    
    $('.awesome-marker.preview').mouseout(function() {
        var color  = $(this).attr('data-color');
        var color2 = $(this).attr('data-color2');
        
        if (color!=color2)
        $(this).removeClass('awesome-marker-icon-'+color2).addClass('awesome-marker-icon-'+color);    
    });
    
    Zmap.admin.filter.bind('#points-form');
    Zmap.admin.autocomplete.geocoding.bind('.place_editor.point input[name=name]');
    Zmap.admin.autocomplete.icons.bind('.place_editor.point input[name=iconType]',Zmap.options.path+'/js/extensions/AwesomeIcons/icons.yml');
    Zmap.admin.autocomplete.markers.bind('#marker-colors,#marker-colors2');
    
});

})(jQuery);