Zmap.admin = {
                filter: {},
                placeeditor: {},
                autocomplete: {geocoding: {}, icons: {items: undefined}, markers: {}},
                changes: false,
                preview: false,
            };
            
(function($) {

Zmap.admin.filter.bind = function(selector) {

    var count_total = parseInt($(selector+' .displaying-num').html().match( /\d+/g )[0]);
    var count_now   = count_total;
    
    $(selector+' .displaying-num').attr('count-total',count_total);
    $(selector+' .displaying-num').attr('count-now',count_now);
    
    $(selector+' .filter-keyup .filter-clear').click(function() {
        $(this).prev('input').val('').trigger('keyup');    
    });;
    
    $(selector+' input[name=filter]').bind('keyup',function() {
        var text  = jQuery(this).val().toLowerCase();
        var count = 0;
        
        $(selector+' td.name').each(function() {
            var name = $(this).find('span:eq(0)').html().toLowerCase();
            
            if (text=='' || text==null) {
                $(this).parent().show(); count++;
            } else {
                if (text!='' && name.indexOf(text)!=-1) {
                    $(this).parent().show(); count++;
                } else {
                    $(this).parent().hide();
                }
            }
           
        });
        
        var count_total = $(selector+' .displaying-num').attr('count-total');
        var count_now   = $(selector+' .displaying-num').attr('count-now');
        
        if (text=='') {
            count = count_total;
            $(selector+' .filter-keyup .filter-clear').hide();
        } else {
            $(selector+' .filter-keyup .filter-clear').show();
        }
        
        $(selector+' .displaying-num').html($(selector+' .displaying-num').html().replace(count_now,count));
        $(selector+' .displaying-num').attr('count-now',count);
    });
    
}
    
Zmap.admin.placeeditor.show = function(selector,elem,callback) {
    callback = callback || function() {};
    
    Zmap.admin.placeeditor.dom  = $(selector);
    
    if ($(elem).hasClass('editinplace')) {
        Zmap.admin.placeeditor.tr = $(elem).parent().parent().parent().parent();   
    } else {
        Zmap.admin.placeeditor.tr = $(Zmap.admin.placeeditor.dom).parent().find('#the-list tr:eq(0)');
    };
    
    Zmap.admin.placeeditor.pos  = $(Zmap.admin.placeeditor.tr).position();

    var tr = Zmap.admin.placeeditor.tr, pos = Zmap.admin.placeeditor.pos, dom = Zmap.admin.placeeditor.dom;
    
    $(dom).css({left: pos.left, top: pos.top, width: $(tr).width()-43});
    
    if ($(dom).filter(':visible').length==0) {
        $(dom).animate({height: 'toggle'},500);
    }
    
    callback.call();
}    
    
Zmap.admin.placeeditor.save = function(selector,callback) {
    callback = callback || function() {};
    
    if (typeof tinyMCE == 'object') {
        tinyMCE.triggerSave();
    }
    
    Zmap.admin.placeeditor.values = {};
    
    var data = 'ajax=1&action=zoomable_map_action&subaction=placeeditor_save';
    
    $(selector).find('input,select,textarea').each(function() {
        if ($(this).attr('name')!=undefined) {
            
            if ($(this).attr('type')=='checkbox' || $(this).attr('type')=='radio') {
                
                if ($(this).prop('checked')) {
                    
                    Zmap.admin.placeeditor.values[$(this).attr('name')] = $(this).val();
            
                    data+='&'+$(this).attr('name')+'='+encodeURIComponent($(this).val()); 
                    
                }
                
            } else {
                Zmap.admin.placeeditor.values[$(this).attr('name')] = $(this).val();
            
                data+='&'+$(this).attr('name')+'='+encodeURIComponent($(this).val());   
            }
        }
    });
    
    $.ajax({
        type: 'POST',
        url: Zmap.options.ajax_url,
        data: data,
    }).done(function(data) {
        $(Zmap.admin.placeeditor.dom).animate({height: 'toggle'},500);
        callback.call($(this),data);
    });
}
    
Zmap.admin.autocomplete.geocoding.bind = function(selector) {

    $(selector).autocomplete({
        source: function(request, response) {

            $.ajax({
                url: "http://nominatim.openstreetmap.org/search?format=json&accept-language=en&q=" + request.term,
                success: function(data) {

                    var items = new Array();
                    for (i = 0; i < data.length; i++) {
                        items.push({
                            value: data[i].display_name,
                            label: data[i].display_name,
                            icon: data[i].icon,
                            lat: data[i].lat,
                            lon: data[i].lon,
                        });
                    }

                    response(items);
                }
            });
        },
        minLength: 3,
        select: function(event, ui) {

            $('.place_editor.point input[name=latitude]').val(ui.item.lat);
            $('.place_editor.point input[name=longitude]').val(ui.item.lon);
            
        },
        open: function() {
            $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
        },
        close: function() {
            $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
        },
        create: function() {
            $(this).data('ui-autocomplete')._renderItem = function(ul, item) {
                var img_style = (item.icon == undefined) ? 'display:none' : 'margin:1px 5px 0 0; float:left';
                return $("<li>")
                    .append("<a><img src='" + item.icon + "' style='" + img_style + "' />" + item.label + "<br /><small>lat: " + item.lat + ', lon: ' + item.lon + "</small></a>")
                    .attr('data-lat', item.lat)
                    .attr('data-lon', item.lon)
                    .appendTo(ul);
            };
        }
    });

}

Zmap.admin.autocomplete.icons.bind = function(selector,yaml_url) {
    
    
    $.widget("custom.combobox", {
            _create: function() {
                this.wrapper = $("<span>")
                    .addClass("custom-combobox")
                    .insertAfter(this.element);
                this.element.hide();
                this._createAutocomplete();
                this._createShowAllButton();
            },
            _createAutocomplete: function() {
                var selected = this.element.children(":selected"),
                    value = selected.val() ? selected.text() : "";
                this.input = $("<input>")
                    .appendTo(this.wrapper)
                    .val(value)
                    .attr("title", "")
                    .addClass("custom-combobox-input ui-widget ui-widget-content ui-state-default ui-corner-left")
                    .autocomplete({
                        delay: 0,
                        minLength: 0,
                        source: $.proxy(this, "_source"),
                        create: function() {
                            $(this).data('ui-autocomplete')._renderItem = function(ul, item) {
                                return $("<li>")
                                    .append("<a><i class=\"fa "+item.icon+"\"></i>" + item.label + "<br /><small>"+item.icon+"</small></a>")
                                    .appendTo(ul);
                            };
                        }
                    })
                    .tooltip({
                        tooltipClass: "ui-state-highlight"
                    });
                this._on(this.input, {
                    autocompleteselect: function(event, ui) {
                        $('input[name=iconType]').val(ui.item.value);
                    },
                    autocompletechange: "_removeIfInvalid"
                });
            },
            _createShowAllButton: function() {
                var input = this.input,
                    wasOpen = false;
                $("<a>")
                    .attr("tabIndex", -1)
                    .attr("title", "Show All Items")
                    .tooltip()
                    .appendTo(this.wrapper)
                    .button({
                        icons: {
                            primary: "ui-icon-triangle-1-s"
                        },
                        text: false
                    })
                    .removeClass("ui-corner-all")
                    .addClass("custom-combobox-toggle ui-corner-right")
                    .mousedown(function() {
                        wasOpen = input.autocomplete("widget").is(":visible");
                    })
                    .click(function() {
                        input.focus();
                        // Close if already visible
                        if (wasOpen) {
                            return;
                        }
                        // Pass empty string as value to search for, displaying all results
                        input.autocomplete("search", "");
                    });
            },
            _source: function(request, response) {
        
                if (Zmap.admin.autocomplete.icons.items == undefined) {
        
                    YAML.fromURL(yaml_url, function(data) {
        
                        var items = new Array();
        
                        if (data.icons != undefined) {
        
                            for (i = 0; i < data.icons.length; i++) {
                                var icon = data.icons[i];
                                items.push({
                                    value: icon.id,
                                    label: icon.name,
                                    icon: 'fa-' + icon.id,
                                });
                            }
        
                            if (data.icons.length > 0) Zmap.admin.autocomplete.icons.items = items;
        
                            var items = new Array();
                            for (var i = 0; i < Zmap.admin.autocomplete.icons.items.length; i++) {
                                var icon = Zmap.admin.autocomplete.icons.items[i];
                                if (icon.label.toLowerCase().indexOf(request.term.toLowerCase()) == -1) {
                                    continue;
                                }
                                items.push(icon);
                            }
                        }
        
        
                        response(items);
        
                    });
        
                } else {
        
                    var items = new Array();
                    for (var i = 0; i < Zmap.admin.autocomplete.icons.items.length; i++) {
                        var icon = Zmap.admin.autocomplete.icons.items[i];
                        if (icon.label.toLowerCase().indexOf(request.term.toLowerCase()) == -1) {
                            continue;
                        }
        
                        items.push(icon);
                    }
        
                    response(items);
        
                }
        
            },
            _removeIfInvalid: function(event, ui) {
                // Selected an item, nothing to do
                if (ui.item) {
                    return;
                }
                // Search for a match (case-insensitive)
                var value = this.input.val(),
                    valueLowerCase = value.toLowerCase(),
                    valid = false;
                this.element.children("option").each(function() {
                    if ($(this).text().toLowerCase() === valueLowerCase) {
                        this.selected = valid = true;
                        return false;
                    }
                });
                // Found a match, nothing to do
                if (valid) {
                    return;
                }
                // Remove invalid value
                this.input
                    .val("")
                    .attr("title", value + " didn't match any item")
                    .tooltip("open");
                this.element.val("");
                this._delay(function() {
                    this.input.tooltip("close").attr("title", "");
                }, 2500);
                this.input.autocomplete("instance").term = "";
            },
            _destroy: function() {
                this.wrapper.remove();
                this.element.show();
            }
        });
        
        $(selector).combobox();
        $("#toggle").click(function() {
            $(selector).toggle();
        });
    
}

Zmap.admin.autocomplete.markers.bind = function(selector) {
    
   $.widget("custom.combobox", {
     _create: function() {
         this.wrapper = $("<span>")
            .addClass("custom-combobox")
            .insertAfter(this.element);
         this.element.hide();
         this._createAutocomplete();
         this._createShowAllButton();
     },
     _createAutocomplete: function() {
         var selected = this.element.children(":selected"),
             value = selected.val() ? selected.text() : "";
         this.input = $("<input>")
             .appendTo(this.wrapper)
             .val(value)
             .attr("title", "")
             .addClass("custom-combobox-input ui-widget ui-widget-content ui-state-default ui-corner-left")
             .autocomplete({
                 delay: 0,
                 minLength: 0,
                 source: $.proxy(this, "_source"),
                 create: function() {
                        $(this).data('ui-autocomplete')._renderItem = function(ul, item) {
                            return $("<li>")
                                .append("<a class=\"marker-ac\"><div class=\"awesome-marker awesome-marker-icon-"+item.value+"\"></div><span>" + item.value + "</span></a>")
                                .appendTo(ul);
                        };
                 }
             })
             .tooltip({
                 tooltipClass: "ui-state-highlight"
             });
         this._on(this.input, {
             autocompleteselect: function(event, ui) {
                 ui.item.option.selected = true;
                 this._trigger("select", event, {
                     item: ui.item.option
                 });
             },
             autocompletechange: "_removeIfInvalid"
         });
     },
     _createShowAllButton: function() {
         var input = this.input,
             wasOpen = false;
         $("<a>")
             .attr("tabIndex", -1)
             .attr("title", "Show All Items")
             .tooltip()
             .appendTo(this.wrapper)
             .button({
                 icons: {
                     primary: "ui-icon-triangle-1-s"
                 },
                 text: false
             })
             .removeClass("ui-corner-all")
             .addClass("custom-combobox-toggle ui-corner-right")
             .mousedown(function() {
                 wasOpen = input.autocomplete("widget").is(":visible");
             })
             .click(function() {
                 input.focus();
                 // Close if already visible
                 if (wasOpen) {
                     return;
                 }
                 // Pass empty string as value to search for, displaying all results
                 input.autocomplete("search", "");
             });
     },
     _source: function(request, response) {
         var matcher = new RegExp($.ui.autocomplete.escapeRegex(request.term), "i");
         response(this.element.children("option").map(function() {
             var text = $(this).text();
             if (this.value && (!request.term || matcher.test(text)))
                 return {
                     label: text,
                     value: text,
                     option: this
                 };
         }));
     },
     _removeIfInvalid: function(event, ui) {
         // Selected an item, nothing to do
         if (ui.item) {
             return;
         }
         // Search for a match (case-insensitive)
         var value = this.input.val(),
             valueLowerCase = value.toLowerCase(),
             valid = false;
         this.element.children("option").each(function() {
             if ($(this).text().toLowerCase() === valueLowerCase) {
                 this.selected = valid = true;
                 return false;
             }
         });
         // Found a match, nothing to do
         if (valid) {
             return;
         }
         // Remove invalid value
         this.input
             .val("")
             .attr("title", value + " didn't match any item")
             .tooltip("open");
         this.element.val("");
         this._delay(function() {
             this.input.tooltip("close").attr("title", "");
         }, 2500);
         this.input.autocomplete("instance").term = "";
     },
     _destroy: function() {
         this.wrapper.remove();
         this.element.show();
     }
  });
  
   $( selector ).combobox();
   $( "#toggle" ).click(function() {
      $( selector ).toggle();
   });
  
}

$(document).ready(function() {
    
    var send_to_editor_default = window.send_to_editor;
    
    $('.tooltip').tooltip();
    
    if ($("#tabs").length>0) {
       $( "#tabs" ).tabs({
            activate: function( event, ui ) {
                   var tab    = $(ui.newTab).attr('data-n');
                   var map_id = $('select[name=map_id]').val();
                   
                   try { localStorage.setItem("tab-n", tab); } catch(e) {}
                   
                   if (tab==2) {
                      if(Zmap.admin.changes || !Zmap.admin.preview) {
                        $('#map-preview').attr('src','?ajax=1&action=zoomable_map_action&subaction=map_preview&map_id='+map_id);
                        Zmap.admin.preview = true;
                      }
                   }
            }     
       }).show();
    }
    
    try { $('#tabs').tabs('option','active', localStorage["tab-n"]); } catch(e) { }
    
    if ($('.colorpicker').length>0) {
        
        $('.colorpicker').each(function(){
            $(this).farbtastic($(this).prev().prev());
            
            $(this).hide();
            
            $(this).prev().prev().bind('focus', function(){
                $(this).next().next().fadeIn();
            });
            
            $(this).prev().prev().bind('blur', function(){
                $(this).next().next().fadeOut();
            });
            
        });
        
    }
    
    
    $('.zoomable-map .button.image').click(function() {
            
        tb_show('', 'media-upload.php?type=image&TB_iframe=1&width=640&height=378');
        
        window.send_to_editor = function(html) {
            tb_remove();
        
            var img = $( 'img', html).attr('src');
            $(Zmap.admin.placeeditor.dom).find('input[name=image]').val(img);
            
            window.send_to_editor = send_to_editor_default;
        }

        return false;
    });

    
    $('.place_editor .button-secondary.cancel').click(function() {
        $(Zmap.admin.placeeditor.dom).animate({height: 'toggle'},500);
        return false;    
    });
    
    $('.editor_toggle').click(function() {
       
       var data_toggle = $(this).attr('data-toggle');
       $(this).attr('data-toggle',$(this).text()).text(data_toggle);
       
       $(this).next().animate({height: 'toggle'},100);
       
       return false;
    });
    
});

})(jQuery);
