FLA.Map.prototype.loadPoints = function(options) {
    var self = this;
    this.clickedPoint = '';
    this.pointOptions = options;
    this.pointsLayer = L.layerGroup()

    document.addEventListener('fla_reset_click', function (e) {
        if (self.clickedPoint != '') {
            self._toolTip();
            self._changeMarker(
                self.clickedPoint.target,
                self.clickedPoint.target.pointData.iconType,
                self.clickedPoint.target.pointData.color,
                self.clickedPoint.target.pointData.iconSize
                )
            self.clickedPoint.target.setIcon(self.clickedPoint.target.Micon);
        }
    }, false);

    for (var key in options) {
        var point = options[key];
        var icon = this.createIcon(point.iconType, point.color, point.iconSize);
        var pointMarker = L.marker(new L.LatLng(point.latitude, point.longitude), {icon: icon});
        (function(pointMarker, icon, point) {
            pointMarker.addTo(self.pointsLayer);
            pointMarker.pointData = point;
            pointMarker.on({
                mouseover: function(e) {
                    self._changeMarker(this, point.iconType, point.color2, point.iconSize);
                    self._toolTip(
                        point.image,
                        point.comment,
                        point.name,
                        point.link
                    );
                },
                mouseout: function(e) {
                    self._changeMarker(this, point.iconType, point.color, point.iconSize);
                    self._toolTip();
                }
            });
            if (L.Browser.touch) {
                if (self.map_options.iOSbehavior) {
                    pointMarker.on({
                        click: function() {
                            if (point.link != '') {
                                if(point.target != '') {
                                    window.open(point.link, point.target);
                                } else {
                                    window.location.assign(point.link);
                                }
                            }
                        }
                    });
                } else {
                    pointMarker.on({
                        dblclick: function() {
                            if (point.link != ''){
                                if(point.target != '') {
                                    window.open(point.link, point.target);
                                } else {
                                    window.location.assign(point.link);
                                }
                            }
                        },
                        click: function(e) {
                            if (self.clickedCountry != '')
                                self._resetHighlight.call(self, self.clickedCountry);
                            if (self.clickedPoint != '') {
                                self._changeMarker(
                                    self.clickedPoint.target,
                                    self.clickedPoint.target.pointData.iconType,
                                    self.clickedPoint.target.pointData.color,
                                    self.clickedPoint.target.pointData.iconSize
                                    )
                            }
                            self._changeMarker(this, point.iconType, point.color2, point.iconSize);
                            self._moveToolTip(e.originalEvent);
                            self._toolTip(
                                point.image,
                                point.comment,
                                point.name,
                                point.link
                            );
                            self.clickedPoint = e;
                        }
                    });
                }
            } else {
                pointMarker.on({
                    click: function(e) {
                        if (point.link != '') {
                            if(point.target != '') {
                                window.open(point.link, point.target);
                            } else {
                                window.location.assign(point.link);
                            }
                        }
                    }
                });
            }
        })(pointMarker, icon, point);
    }
    this.pointsLayer.addTo(this.map);
}

FLA.Map.prototype.createPoint = function(point) {
    var icon = L.MakiMarkers.icon({icon: point.iconType, color: point.color, size: point.iconSize});
    var marker = L.marker(new L.LatLng(point.latitude, point.longitude), {icon: icon});
    return marker
}

FLA.Map.prototype._changeMarker = function(marker, type, color, size) {
    var icon = this.createIcon(type, color, size);
    marker.setIcon(icon);
}